/*
No Special Stages
	by Lach
v1
Reusable!
*/

local function GetNextEmerald(g)
	local n = 1

	while g & 1
		n = $ + 1
		g = $ >> 1
	end
	
	return n
end

addHook("TouchSpecial", function(mo, toucher)
	local player = toucher.player

	if modeattacking
	or not (gametyperules & GTR_SPECIALSTAGES)
	or All7Emeralds(emeralds)
	or player.bot
		return
	end

	local nextemerald = GetNextEmerald(emeralds)
	
	if nextemerald > 7
		return
	end
	
	emeralds = $ | (1 << (nextemerald - 1))
	
	S_StartSound(toucher, sfx_cgot)
	P_AddPlayerScore(player, 1000)
	P_RemoveMobj(mo)
	return true
end, MT_TOKEN)

addHook("MobjThinker", function(mo)
	if modeattacking
	or not (gametyperules & GTR_SPECIALSTAGES)
	or (OLDC and (gamemap < OLDC.firstmap or gamemap > OLDC.firstmap + TOTALENTRIES - 1))
	or All7Emeralds(emeralds)
		if not mo.gobacktonormal
			mo.state = S_SPAWNSTATE
			mo.gobacktonormal = true
		end
		
		return
	end
	
	local nextemerald = GetNextEmerald(emeralds)
	
	if nextemerald > 7
		return
	end
	
	mo.state = S_CEMG1 + nextemerald - 1
end, MT_TOKEN)